## enbd 2.4.31-20040412-1

=== Makefile ===

# be careful to keep the spacing in the defines - it counts

export

###################### make targets ########################
#
#   make config          prepares compilation
#   make all             makes driver, server and client
#   make test            minor test example
#   make clean           removes compile from BUILD dir
#   make distclean       removes config cache as well
#   make install         installs driver, utils, manpages
#
############################################################

#################### compile options #######################
#
# turn on to enable SSL channels
USING_SSL    = 0
# debug level
DEBUG        = 0
# root of build
BUILD        = /tmp
# will module be on an SMP machine
SMP          = 0
# where the kernel sources are
LINUXDIR     = /usr/src/linux
# which compiler to use (KCC is for the kernel modules)
CC           = gcc
KCC          = gcc
#
############################################################

#################### install options #######################
# placements
PREFIX       = $(DESTDIR)/usr/local
#
KERNELVERSION := $(shell grep UTS_RELEASE $(LINUXDIR)/include/linux/version.h|cut -f 2 -d'"')
KERNELMAJOR=$(shell echo $(KERNELVERSION) | sed -e 's/[.][^.]*$$//' | tr -d '\n')
#
MODDIR       = $(DESTDIR)/lib/modules/$(KERNELVERSION)/misc
#
ENBDVERSION := 2.4.31
#
INSTALL      = install
#
############################################################

###################### run options #########################
#
# server machine (runs enbd-server)
SERVER       = localhost
# client machine (runs enbd-client and enbd.o)
CLIENT       = localhost
# client whole device name
DEVICE       = /dev/ndb
# server builds these resources for export
EXPORT0      = /tmp/core0 /tmp/core1
EXPORT1      = /tmp/core2 /tmp/core3
# each of this many blocks
SRVSIZ       = 4096
# blocksize on client and server 1024, 2048, 4096
BLKSIZ       = 1024
# control port
PORT0        = 3033
PORT1        = 4044
# how many parallel channels (otherwise use server addr repeats)
OPTSOCK      = -n 4
#OPTSOCK     := $(SERVER) $(SERVER) $(SERVER) $(SERVER)
# session signature                        - default = random
OPTSIG       = -i "NBDabcdefNBD"
# blocksize                                - default = 1024B or highest offer
OPTBLK       = -b $(BLKSIZ)
# use raid linear or raid 0 or raid 1 on server - default = linear
OPTRAID      = -0
# timeout for first negotiate              - default = 60s
OPTTIME      = -t 120
# readonly on server side
OPTRO        = #-r
# server maintains write order until this many ms delay - default = 0ms
OPTORDER     = -w 500
# client uses checksumming protocol at startup
OPTMD5SUM    = #-m
# journalling
OPTJRNL      = #-j /tmp/nbd.log
# module readahead in blocks
RAHEAD       = 20
# module-based request aggregation (default 0)
MERGE_REQS   = 0
# module should check for partition table
CHK_PART     = 0
# module timeout seconds on daemon service
OPT_REQ_TIMEO= -p 5
# module force sync every n seconds
SYNC_INTVL   = 0
# make client asyncronous (default, no). client acks before net replies.
OPTASYNC     = #-a
# make server lock regions on accesses so multiple clients are OK.
OPTLOCK      = #-k
# make server async (default, no)
OPTSASYNC    = #-a
# server result caching
OPTRCACHE    = -h 0
# enbd module parameters
MODPARMS     = rahead=$(RAHEAD) merge_requests=$(MERGE_REQS) \
               sync_intvl=$(SYNC_INTVL) check_partitions=$(CHK_PART)
#
############################################################


ifeq ($(USING_SSL),1)
SSLSUBDIR    =
CAPATH       =$(SSLSUBDIR)/demoCA
CAFILE       =cacert.pem
SERVERCERT   =$(SSLSUBDIR)/$(SERVER)_server.pem
CLIENTCERT   =$(SSLSUBDIR)/$(CLIENT)_client.pem
OPTCAPATH    = -CApath $(BUILD)/$(CAPATH)
OPTCAFILE    = -CAfile $(BUILD)/$(CAFILE)
OPTSCERT     = -cert $(BUILD)/$(SERVERCERT)
OPTCCERT     = -cert $(BUILD)/$(CLIENTCERT)
OPTVERIFY    = -verify 1
OPTFASTCIPHER= -cipher EXP-RC4-MD5
OPTCLISSL    = $(OPTCAFILE) $(OPTCCERT) $(OPTVERIFY) #$(OPTFASTCIPHER)
OPTSRVSSL    = $(OPTCAFILE) $(OPTSCERT) $(OPTVERIFY)   
endif
OPTSIZ       = -s $(shell echo $$[ $(SRVSIZ) * ( $(BLKSIZ) / 1024 ) ])

OPTCLI       = $(SERVER):$(PORT0) $(OPTSOCK) $(OPTBLK) $(OPTSIG) $(OPTTIME) $(OPTMD5SUM) $(OPTCLISSL) $(OPT_REQ_TIMEO) $(OPTJRNL) $(OPTASYNC) -d 1 $(DEVICE)
#OPTCLI       = $(SERVER):$(PORT0) $(OPTSOCK) +$(SERVER):$(PORT0) $(OPTSOCK) $(OPTBLK) $(OPTSIG) $(OPTTIME) $(OPTMD5SUM) $(OPTCLISSL) $(OPT_REQ_TIMEO) $(OPTJRNL) $(OPTASYNC) -d 1 $(DEVICE)
#OPTCLI       = $(SERVER):$(PORT0) $(OPTSOCK) +file\$$/tmp/core:$(PORT0) $(OPTSOCK) $(OPTBLK) $(OPTSIG) $(OPTTIME) $(OPTMD5SUM) $(OPTCLISSL) $(OPT_REQ_TIMEO) $(OPTJRNL) $(OPTASYNC) -d 1 $(DEVICE)
OPTSRV       = $(PORT0) $(EXPORT0) $(OPTSIG) $(OPTTIME) $(OPTBLK) $(OPTRAID) $(OPTSRVSSL) $(OPTRO) $(OPTORDER) $(OPTLOCK) $(OPTSASYNC) $(OPTRCACHE)


VPATH       := $(shell pwd)

CFLAGS       = -D_LARGEFILE64_SOURCE=1 -D_LARGEFILE_SOURCE=1 \
               -D_GNU_SOURCE=1 -D_XOPEN_SOURCE=1 -D_FILE_OFFSET_BITS=64 \
               -Wall

ifeq ($(DEBUG),0)
  CFLAGS    += -O2
else
  CFLAGS    += -O -g
endif
ifneq ($(SMP),0)
EXTRA_CFLAGS+= -D__SMP__ -DCONFIG_X86_LOCAL_APIC
endif

DATE        := $(shell date)
LIBS         =
LDFLAGS      =
MODULES      = enbd.o enbd_bufferwr.o enbd_ioctl.o enbd_raw.o
ifeq ($(USING_SSL),1)
EXTRA_CFLAGS+= -DUSING_SSL=1
EXTRA_LIBS  += -lssl -lcrypto # -lsocket -lnsl
EXTRA_LDFLAGS=
endif

ifeq ($(ARCH),um)
SUBARCH := $(shell uname -m | sed -e 's/i.86/i386/' -e 's/sun4u/sparc64/' -e 's/arm.*/arm/' -e 's/sa110/arm/')
EXTRA_CFLAGS+=  -DUM_FASTCALL  \
		-D__arch_$(ARCH)__ \
		-DSUBARCH=\"$(SUBARCH)\" \
		-D_LARGEFILE64_SOURCE \
		-I$(LINUXDIR)/arch/$(ARCH)/include \
		-Derrno=kernel_errno \
		-I$(LINUXDIR)/arch/$(ARCH)/kernel/tt/include \
		-I$(LINUXDIR)/arch/$(ARCH)/kernel/skas/include
endif

SYSTEM      := $(shell uname -s)

.PHONY: config

all: utils module 

config: $(BUILD)/configure
	export CONFIG_SITE=$(VPATH)/conf/config.$(SYSTEM); \
	cd $(BUILD);  ./configure --srcdir=$(VPATH)/nbd \
                                  --with-kernel-srcdir=$(LINUXDIR); \
	$(MAKE) VPATH=$(VPATH)/nbd \
                CFLAGS="$(CFLAGS) \
                      -I$(BUILD) \
                      -I$(VPATH)/kernel/linux/include \
                      $(EXTRA_CFLAGS) -DDEBUG=$(DEBUG)" \
                EXTRA_LIBS="$(EXTRA_LDFLAGS) $(LIBS) $(EXTRA_LIBS)" \
                $@

nbd/configure: nbd/configure.in
	autoconf $< > $@; chmod +x $@

$(BUILD)/configure: nbd/configure.in
	mkdir -p $(BUILD)
	autoconf $< > $@; chmod +x $@

$(BUILD)/Makefile: $(BUILD)/configure
	$(MAKE) config

utils: $(BUILD)/Makefile
	$(MAKE) -C $(BUILD) VPATH=$(VPATH)/nbd \
                            CFLAGS="$(CFLAGS) \
                                  -I$(BUILD) \
                                  -I$(VPATH)/kernel/linux/include \
                                  -I$(LINUXDIR)/include \
                                    $(EXTRA_CFLAGS) \
                                  -DDEBUG=$(DEBUG)" \
                            EXTRA_LIBS="$(EXTRA_LDFLAGS) \
                                        $(LIBS) $(EXTRA_LIBS)" 


module:
	test $(KERNELMAJOR) = 2.6 && { echo please apply kernel patch instead; exit 0; }; \
	for file in $(MODULES); do \
	$(MAKE) -C $(BUILD) \
                -f $(VPATH)/kernel/linux/drivers/block/Makefile \
                   VPATH=$(VPATH)/kernel/linux/drivers/block \
                   CONFIG_BLK_DEV_NBD=m \
                   CC="$(KCC)" \
                   EXTRA_CFLAGS="$(EXTRA_CFLAGS) \
                               -D__KERNEL__ \
                               -DMODULE \
                               -DDEBUG=$(DEBUG) \
                               -DCONFIG_ENBD=m \
                               -DENBD_VERSION='\"$(ENBDVERSION) Date: $(DATE)\"' \
                               -I$(VPATH)/kernel/linux/include \
                               -I$(LINUXDIR)/include" \
                   TOPDIR=$(LINUXDIR) \
                   $$file ; \
        done

distclean: clean
	$(MAKE) -C $(BUILD) VPATH=$(VPATH)/nbd $@

clean: utils-clean module-clean

utils-clean:
	$(MAKE) -C $(BUILD) VPATH=$(VPATH)/nbd clean

module-clean:
	cd $(BUILD) && rm -f enbd.o .enbd.o.flags enbd_*.o .enbd_*.o.flags 

install: utils-install module-install

utils-install:
	$(MAKE) -C $(BUILD) VPATH=$(VPATH)/nbd PREFIX="$(PREFIX)" install

module-install:
	mkdir -p $(MODDIR)
	for m in $(MODULES); do \
	        $(INSTALL) $(BUILD)/$$m $(MODDIR)/$$m; \
        done

devices:
	cd /dev; $(VPATH)/nbd/scripts/MAKEDEV $(DEVICE)

FILES := $(shell cat $(VPATH)/FILES)


IS_SRV:=$(shell [ localhost = $(SERVER) -o `hostname | sed -e 's/.*[.]//'` = $(SERVER) ] && echo yes || echo no)
IS_CLI:=$(shell [ localhost = $(CLIENT) -o `hostname | sed -e 's/.*[.]//'` = $(CLIENT) ] && echo yes || echo no)

RSYNC := rsync

ifeq ($(IS_SRV),yes)
  # CMI is interactive, CMD is not
  SRVCMD:= sh -c 
  SRVCMI:= sh -c
  SRVCPY:= cp -a
  SRVYPC:= cp -a
else
  SRVCMD:= ssh -n $(SERVER)
  SRVCMI:= ssh $(SERVER)
  define SRVCPY
    copy(){ \
      $(RSYNC) -uav --rsh=ssh "$$1" "$(SERVER):$$2" ; \
    } ; \
    copy 
  endef
  define SRVYPC
    copy(){ \
      $(RSYNC) -uav --rsh=ssh "$(SERVER):$$1" "$$2" ; \
    } ; \
    copy 
  endef
endif
ifeq ($(IS_CLI),yes)
  # CMI is interactive, CMD is not
  CLICMD:= sh -c 
  CLICMI:= sh -c
  CLICPY:= $(RSYNC) -uav --rsh=ssh 
  CLIYPC:= $(RSYNC) -uav --rsh=ssh
else
  CLICMD:= ssh -n $(CLIENT)
  CLICMI:= ssh $(CLIENT)
  define CLICPY
    copy(){ \
      $(RSYNC) -uav --rsh=ssh "$$1" "$(CLIENT):$$2" ; \
    } ; \
    copy 
  endef
  define CLIYPC
    copy(){ \
      $(RSYNC) -uav --rsh=ssh "$(CLIENT):$$1" "$$2" ; \
    } ; \
    copy 
  endef
endif


notest: test-notice test-server test-delay test-client
test: test-notice test-server test-delay test-client test-device
	echo done

test-notice:
	-@echo "server:$(SERVER) <- $(PORT0) -> client:$(CLIENT)"
	-@echo "server:$(SERVER) <- $(PORT1) -> client:$(CLIENT)"

ifeq ($(USING_SSL),1)
install-server-certs:
	$(MAKE) -C $(BUILD) -f $(VPATH)/ssl/Makefile VPATH=$(VPATH)/ssl $@
install-client-certs:
	$(MAKE) -C $(BUILD) -f $(VPATH)/ssl/Makefile VPATH=$(VPATH)/ssl $@
install-master-certs:
	$(MAKE) -C $(BUILD) -f $(VPATH)/ssl/Makefile VPATH=$(VPATH)/ssl $@
install-all-certs:
	$(MAKE) -C $(BUILD) -f $(VPATH)/ssl/Makefile VPATH=$(VPATH)/ssl $@
install-clean:
	$(MAKE) -C $(BUILD) -f $(VPATH)/ssl/Makefile VPATH=$(VPATH)/ssl $@
else
install-server-certs:
install-client-certs:
install-master-certs:
install-all-certs:
install-clean:
endif 

IS_ROOT := $(shell [ `id -u` = 0 ] && echo yes || echo no)
ifeq ($(IS_ROOT),yes)
SUDO := 
else
SUDO := sudo
endif


kill-server:
	-echo; echo; \
	 stty -echo </dev/tty ; \
	 $(SRVCMI) "$(SUDO) echo kill enbd-server" ; \
	 stty echo </dev/tty ;  \
	 $(SRVCMD) "$(SUDO) killall enbd-server; sleep 1; $(SUDO) killall -9 enbd-server" 

test-server: install-server-certs kill-server
	-echo; echo; \
	 stty -echo </dev/tty ; \
	 $(SRVCMI) "$(SUDO) echo enbd-server" ; \
	 stty echo </dev/tty ;  \
	 $(SRVCPY) $(BUILD)/enbd-server $(BUILD)/  ; \
	 for i in $(EXPORT0) $(EXPORT1); do $(SRVCMD) "test -s $$i || dd if=/dev/zero  bs=$(BLKSIZ) count=$(SRVSIZ) >$$i" ; done ; \
	 $(SRVCMD) "$(SUDO) nice -19 $(BUILD)/enbd-server $(OPTSRV) ; pstree -p | grep enbd-server; sleep 300" & 

test-delay:
	-@echo -n delay 5s ..; sleep 5 ; echo .

test-device:
	$(CLICMD) "$(SUDO) $(BUILD)/enbd-test $(DEVICE) -s 1M -i 1:2:3:4:5"

kill-client:
	-echo; echo; \
	 stty -echo </dev/tty ; \
	 $(CLICMI) "$(SUDO) echo kill enbd-client"  ; \
	 stty echo </dev/tty ; \
	 $(CLICMD) "$(SUDO) killall -USR1 enbd-client ; sleep 1; $(SUDO) killall -9 enbd-client; sleep 4; #$(SUDO) /sbin/rmmod enbd" 

test-client: install-client-certs kill-client
	-echo; echo; \
	 stty -echo </dev/tty ; \
	 $(CLICMI) "$(SUDO) echo enbd-client"  ; \
	 stty echo </dev/tty ; \
	 $(CLICPY) $(BUILD)/enbd.o  $(BUILD)/ ; \
	 $(CLICPY) $(BUILD)/enbd-client $(BUILD)/ ; \
	 $(CLICPY) $(VPATH)/nbd/scripts/MAKEDEV $(BUILD)/ ; \

=== nbd/ssl/Makefile ===

export


install-server-certs: built-$(SERVER)-server-post
install-client-certs: built-$(CLIENT)-client-post
install-master-certs: built-master
install-all-certs: install-server-certs install-client-certs
install-clean: clean


IS_SRV:=$(shell [ localhost = $(SERVER) -o `hostname -s` = $(SERVER) ] && echo yes || echo no)
IS_CLI:=$(shell [ localhost = $(CLIENT) -o `hostname -s` = $(CLIENT) ] && echo yes || echo no)

ifeq ($(IS_SRV),yes)
  SRVCMD:= sh -c 
  SRVCMI:= sh -c
  SRVCPY:= cp -a
  SRVYPC:= cp -a
else
  SRVCMD:= ssh -n $(SERVER)
  SRVCMI:= ssh $(SERVER)
  define SRVCPY
    copy(){ \
      rsync    -uav --rsh=ssh "$$1" "$(SERVER):$$2" ; \
    } ; \
    copy 
  endef
  define SRVYPC
    copy(){ \
      rsync    -uav --rsh=ssh "$(SERVER):$$1" "$$2" ; \
    } ; \
    copy
  endef
endif
ifeq ($(IS_CLI),yes)
  CLICMD:= sh -c 
  CLICMI:= sh -c
  CLICPY:= rsync -uav --rsh=ssh 
  CLIYPC:= rsync -uav --rsh=ssh
else
  CLICMD:= ssh -n $(CLIENT)
  CLICMI:= ssh $(CLIENT)
  define CLICPY
    copy(){ \
      rsync    -uav --rsh=ssh "$$1" "$(CLIENT):$$2" ; \
    } ; \
    copy 
  endef
  define CLIYPC
    copy(){ \
      rsync    -uav --rsh=ssh "$(CLIENT):$$1" "$$2" ; \
    } ; \
    copy 
  endef
endif


# this makes demoCA/private/cakey.pem and demoCA/cacert.pem
# cacert.pem is the cert that will be needed in the negotiation
built-master:
	-mkdir -p demoCA ; \
	rsync -uav --exclude demoCA $(VPATH)/ ./ ; \
	sh testca -ca ; \
	touch $@

# client stuff
# make CLIENT_c_req.pem, CLIENT_client.pem, built-CLIENT-client-*

built-$(CLIENT)-client-pre: built-master
	-$(CLICMD) "mkdir -p $(BUILD)" ; \
	$(CLICPY) client.cnf $(BUILD)/ ; \
	$(CLICPY) testca $(BUILD)/ ; \
	$(CLICPY) miCA.sh $(BUILD)/ ; \
	$(CLICMD) "cd $(BUILD); sh testca -req $(CLIENT)_c" ; \
	touch $@

$(CLIENT)_c_cert.pem: built-master $(CLIENT)_c_req.pem
	-sh testca -cert $(CLIENT)_c

$(CLIENT)_client.pem: built-master $(CLIENT)_c_cert.pem
	-cat $(CLIENT)_c_cert.pem $(CLIENT)_c_req.pem > $@ 

built-$(CLIENT)-client-post: built-master $(CLIENT)_client.pem
	-$(CLICPY) $(CLIENT)_client.pem $(BUILD)/ ; \
	$(CLICPY) demoCA/cacert.pem $(BUILD)/ ; \
	touch $@

$(CLIENT)_c_req.pem: built-$(CLIENT)-client-pre
	-$(CLIYPC) $(BUILD)/$@ $@

# server stuff

built-$(SERVER)-server-pre: built-master 
	-$(SRVCMD) "mkdir -p $(BUILD)" ; \
	$(SRVCPY) server.cnf $(BUILD)/ ;\
	$(SRVCPY) testca $(BUILD)/ ;\
	$(SRVCPY) miCA.sh $(BUILD)/ ;\
	$(SRVCMD) "cd $(BUILD); sh testca -req $(SERVER)_s server" ; \
	touch $@

$(SERVER)_s_req.pem: built-$(SERVER)-server-pre
	-$(SRVYPC) $(BUILD)/$@ $@

$(SERVER)_s_cert.pem: built-master $(SERVER)_s_req.pem
	-sh testca -cert $(SERVER)_s server

$(SERVER)_server.pem: built-master $(SERVER)_s_cert.pem $(SERVER)_s_req.pem 
	-cat $(SERVER)_s_cert.pem $(SERVER)_s_req.pem > $@ 

built-$(SERVER)-server-post: built-master $(SERVER)_server.pem
	-$(SRVCPY) $(SERVER)_server.pem $(BUILD)/ ; \
	$(SRVCPY) demoCA/cacert.pem $(BUILD)/ ; \
	touch $@


demoCA/cacert.pem: built-master

clean:
	rm -f built-* *.pem ; \
	find $(BUILD) -type f -name "*.pem" -exec rm {} \;

=== kernel/linux/drivers/block/Makefile ===
#
# Makefile for the kernel block device drivers.
#
# Note! Dependencies are done automagically by 'make dep', which also
# removes any old dependencies. DON'T put your own dependencies here
# unless it's something special (ie not a .c file).
#
# Note 2! The CFLAGS definition is now inherited from the
# parent makefile.
#

#
# Note : at this point, these files are compiled on all systems.
# In the future, some of these should be built conditionally.
#

SUB_DIRS     := 
MOD_SUB_DIRS := $(SUB_DIRS)
ALL_SUB_DIRS := $(SUB_DIRS) paride


L_TARGET := block.a
L_OBJS   := genhd.o
M_OBJS   :=
MOD_LIST_NAME := BLOCK_MODULES
LX_OBJS := ll_rw_blk.o
MX_OBJS :=

ifeq ($(CONFIG_MAC_FLOPPY),y)
L_OBJS += swim3.o
endif

ifeq ($(CONFIG_BLK_DEV_FD),y)
L_OBJS += floppy.o
else
  ifeq ($(CONFIG_BLK_DEV_FD),m)
  M_OBJS += floppy.o
  endif
endif

ifeq ($(CONFIG_AMIGA_FLOPPY),y)
  L_OBJS += amiflop.o
else
  ifeq ($(CONFIG_AMIGA_FLOPPY),m)
    M_OBJS += amiflop.o
  endif
endif

ifeq ($(CONFIG_ATARI_FLOPPY),y)
  L_OBJS += ataflop.o
else
  ifeq ($(CONFIG_ATARI_FLOPPY),m)
  M_OBJS += ataflop.o
  endif
endif

ifeq ($(CONFIG_ATARI_ACSI),y)
  LX_OBJS += acsi.o
else
  ifeq ($(CONFIG_ATARI_ACSI),m)
  MX_OBJS += acsi.o
  endif
endif

ifeq ($(CONFIG_ATARI_SLM),y)
  L_OBJS += acsi_slm.o
else
  ifeq ($(CONFIG_ATARI_SLM),m)
  M_OBJS += acsi_slm.o
  endif
endif

ifeq ($(CONFIG_AMIGA_Z2RAM),y)
L_OBJS += z2ram.o
else
  ifeq ($(CONFIG_AMIGA_Z2RAM),m)
  M_OBJS += z2ram.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_RAM),y)
L_OBJS += rd.o
else
  ifeq ($(CONFIG_BLK_DEV_RAM),m)
  M_OBJS += rd.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_LOOP),y)
LX_OBJS += loop.o
else
  ifeq ($(CONFIG_BLK_DEV_LOOP),m)
  MX_OBJS += loop.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_HD),y)
L_OBJS += hd.o
endif

ifeq ($(CONFIG_BLK_DEV_RZ1000),y)
IDE_OBJS += rz1000.o
endif

ifeq ($(CONFIG_BLK_DEV_CMD640),y)
IDE_OBJS += cmd640.o
endif

ifeq ($(CONFIG_BLK_DEV_IDE_PMAC),y)
IDE_OBJS += ide-pmac.o
endif

ifeq ($(CONFIG_BLK_DEV_IDEPCI),y)
IDE_OBJS += ide-pci.o
endif

ifeq ($(CONFIG_BLK_DEV_IDEDMA),y)
IDE_OBJS += ide-dma.o
endif

ifeq ($(CONFIG_BLK_DEV_DTC2278),y)
IDE_OBJS += dtc2278.o
endif

ifeq ($(CONFIG_BLK_DEV_HT6560B),y)
IDE_OBJS += ht6560b.o
endif

ifeq ($(CONFIG_BLK_DEV_QD6580),y)
IDE_OBJS += qd6580.o
endif

ifeq ($(CONFIG_BLK_DEV_UMC8672),y)
IDE_OBJS += umc8672.o
endif

ifeq ($(CONFIG_BLK_DEV_ALI14XX),y)
IDE_OBJS += ali14xx.o
endif

ifeq ($(CONFIG_BLK_DEV_PDC4030),y)
IDE_OBJS += pdc4030.o
endif

ifeq ($(CONFIG_BLK_DEV_TRM290),y)
IDE_OBJS += trm290.o
endif

ifeq ($(CONFIG_BLK_DEV_OPTI621),y)
IDE_OBJS += opti621.o
endif

ifeq ($(CONFIG_BLK_DEV_NS87415),y)
IDE_OBJS += ns87415.o
endif

ifeq ($(CONFIG_BLK_DEV_VIA82C586),y)
IDE_OBJS += via82c586.o
endif

ifeq ($(CONFIG_BLK_DEV_CMD646),y)
IDE_OBJS += cmd646.o
endif

ifeq ($(CONFIG_BLK_DEV_SL82C105),y)
IDE_OBJS += sl82c105.o
endif

### if CONFIG_BLK_DEV_IDE is n, IDE_OBJS will be ignored

ifeq ($(CONFIG_PROC_FS),y)
IDE_OBJS += ide-proc.o
endif
  
###Collect

ifeq ($(CONFIG_BLK_DEV_IDE),y)
  LX_OBJS += ide.o
  L_OBJS += ide-probe.o $(IDE_OBJS)
else
  ifeq ($(CONFIG_BLK_DEV_IDE),m)
  MIX_OBJS += ide.o $(IDE_OBJS)
  M_OBJS += ide-mod.o ide-probe.o
  endif
endif

############

ifeq ($(CONFIG_BLK_DEV_IDEDISK),y)
L_OBJS += ide-disk.o
else
  ifeq ($(CONFIG_BLK_DEV_IDEDISK),m)
  M_OBJS += ide-disk.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_IDECD),y)
L_OBJS += ide-cd.o
else
  ifeq ($(CONFIG_BLK_DEV_IDECD),m)
  M_OBJS += ide-cd.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_IDETAPE),y)
L_OBJS += ide-tape.o
else
  ifeq ($(CONFIG_BLK_DEV_IDETAPE),m)
  M_OBJS += ide-tape.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_IDEFLOPPY),y)
L_OBJS += ide-floppy.o
else
  ifeq ($(CONFIG_BLK_DEV_IDEFLOPPY),m)
  M_OBJS += ide-floppy.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_PS2),y)
L_OBJS += ps2esdi.o
else
  ifeq ($(CONFIG_BLK_DEV_PS2),m)
  M_OBJS += ps2esdi.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_XD),y)
L_OBJS += xd.o
else
  ifeq ($(CONFIG_BLK_DEV_XD),m)
  M_OBJS += xd.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_MD),y)
LX_OBJS += md.o

ifeq ($(CONFIG_MD_LINEAR),y)
L_OBJS += linear.o
else
  ifeq ($(CONFIG_MD_LINEAR),m)
  M_OBJS += linear.o
  endif
endif

ifeq ($(CONFIG_MD_STRIPED),y)
L_OBJS += raid0.o
else
  ifeq ($(CONFIG_MD_STRIPED),m)
  M_OBJS += raid0.o
  endif
endif

ifeq ($(CONFIG_MD_MIRRORING),y)
L_OBJS += raid1.o
else
  ifeq ($(CONFIG_MD_MIRRORING),m)
  M_OBJS += raid1.o
  endif
endif

ifeq ($(CONFIG_MD_RAID5),y)
L_OBJS += raid5.o
else
  ifeq ($(CONFIG_MD_RAID5),m)
  M_OBJS += raid5.o
  endif
endif

endif

ifeq ($(CONFIG_BLK_DEV_ENBD),y)
L_OBJS += enbd.o enbd_ioctl.o enbd_bufferwr.o enbd_raw.o
else
  ifeq ($(CONFIG_BLK_DEV_ENBD),m)
  M_OBJS += enbd.o enbd_ioctl.o enbd_bufferwr.o enbd_raw.o
  endif
endif

ifeq ($(CONFIG_PARIDE),y)
SUB_DIRS	+= paride
MOD_IN_SUB_DIRS	+= paride
else
  ifeq ($(CONFIG_PARIDE),m)
  MOD_IN_SUB_DIRS	+= paride
  endif
endif

include $(TOPDIR)/Rules.make

ide-mod.o: ide.o $(IDE_OBJS)
	$(LD) $(LD_RFLAG) -r -o $@ ide.o $(IDE_OBJS)

=== kernel/snapshots/linux-2.5.64/drivers/Makefile ===
#
# Makefile for the Linux kernel device drivers.
#
# 15 Sep 2000, Christoph Hellwig <hch@infradead.org>
# Rewritten to use lists instead of if-statements.
#

obj-$(CONFIG_PCI)		+= pci/
obj-$(CONFIG_PARISC)		+= parisc/
obj-$(CONFIG_ACPI)		+= acpi/
# PnP must come after ACPI since it will eventually need to check if acpi
# was used and do nothing if so
obj-$(CONFIG_PNP)		+= pnp/
obj-y				+= serial/
obj-$(CONFIG_PARPORT)		+= parport/
obj-y				+= base/ char/ block/ misc/ net/ media/
obj-$(CONFIG_NUBUS)		+= nubus/
obj-$(CONFIG_ATM)		+= atm/
obj-$(CONFIG_IDE)		+= ide/
obj-$(CONFIG_FC4)		+= fc4/
obj-$(CONFIG_SCSI)		+= scsi/
obj-$(CONFIG_FUSION)		+= message/
obj-$(CONFIG_IEEE1394)		+= ieee1394/
obj-y				+= cdrom/ video/
obj-$(CONFIG_MTD)		+= mtd/
obj-$(CONFIG_PCMCIA)		+= pcmcia/
obj-$(CONFIG_DIO)		+= dio/
obj-$(CONFIG_SBUS)		+= sbus/
obj-$(CONFIG_ZORRO)		+= zorro/
obj-$(CONFIG_ALL_PPC)		+= macintosh/
obj-$(CONFIG_MAC)		+= macintosh/
obj-$(CONFIG_SGI)		+= sgi/
obj-$(CONFIG_ENBD) 		+= block/enbd/
obj-$(CONFIG_PARIDE) 		+= block/paride/
obj-$(CONFIG_TC)		+= tc/
obj-$(CONFIG_USB)		+= usb/
obj-$(CONFIG_INPUT)		+= input/
obj-$(CONFIG_GAMEPORT)		+= input/gameport/
obj-$(CONFIG_SERIO)		+= input/serio/
obj-$(CONFIG_I2O)		+= message/
obj-$(CONFIG_I2C)		+= i2c/
obj-$(CONFIG_PHONE)		+= telephony/
obj-$(CONFIG_MD)		+= md/
obj-$(CONFIG_BT)		+= bluetooth/
obj-$(CONFIG_HOTPLUG_PCI)	+= hotplug/
obj-$(CONFIG_ISDN_BOOL)		+= isdn/
obj-$(CONFIG_MCA)		+= mca/
obj-$(CONFIG_EISA)		+= eisa/
obj-$(CONFIG_CPU_FREQ)		+= cpufreq/

=== kernel/snapshots/linux-2.0.36/drivers/block/Makefile ===
#
# Makefile for the kernel block device drivers.
#
# Note! Dependencies are done automagically by 'make dep', which also
# removes any old dependencies. DON'T put your own dependencies here
# unless it's something special (ie not a .c file).
#
# Note 2! The CFLAGS definition is now inherited from the
# parent makefile.
#

#
# Note : at this point, these files are compiled on all systems.
# In the future, some of these should be built conditionally.
#


L_TARGET := block.a
L_OBJS   := ll_rw_blk.o genhd.o
M_OBJS   :=
MOD_LIST_NAME := BLOCK_MODULES
LX_OBJS :=

ifeq ($(CONFIG_BLK_DEV_FD),y)
L_OBJS += floppy.o
else
  ifeq ($(CONFIG_BLK_DEV_FD),m)
  M_OBJS += floppy.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_RAM),y)
L_OBJS += rd.o
else
  ifeq ($(CONFIG_BLK_DEV_RAM),m)
  M_OBJS += rd.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_LOOP),y)
L_OBJS += loop.o
else
  ifeq ($(CONFIG_BLK_DEV_LOOP),m)
  M_OBJS += loop.o
  endif
endif

ifeq ($(CONFIG_BLK_DEV_HD),y)
L_OBJS += hd.o
endif

ifeq ($(CONFIG_BLK_DEV_IDE),y)
L_OBJS += ide.o
endif

ifeq ($(CONFIG_BLK_DEV_RZ1000),y)
L_OBJS += rz1000.o
endif

ifeq ($(CONFIG_BLK_DEV_CMD640),y)
L_OBJS += cmd640.o
endif

ifeq ($(CONFIG_BLK_DEV_TRITON),y)
L_OBJS += triton.o
endif

ifeq ($(CONFIG_BLK_DEV_DTC2278),y)
L_OBJS += dtc2278.o
endif

ifeq ($(CONFIG_BLK_DEV_HT6560B),y)
L_OBJS += ht6560b.o
endif

ifeq ($(CONFIG_BLK_DEV_QD6580),y)
L_OBJS += qd6580.o
endif

ifeq ($(CONFIG_BLK_DEV_UMC8672),y)
L_OBJS += umc8672.o
endif

ifeq ($(CONFIG_BLK_DEV_ALI14XX),y)
L_OBJS += ali14xx.o
endif

ifeq ($(CONFIG_BLK_DEV_PROMISE),y)
L_OBJS += promise.o
endif

ifeq ($(CONFIG_BLK_DEV_IDECD),y)
L_OBJS += ide-cd.o
endif

ifeq ($(CONFIG_BLK_DEV_IDETAPE),y)
L_OBJS += ide-tape.o
endif

ifeq ($(CONFIG_BLK_DEV_IDEFLOPPY),y)
L_OBJS += ide-floppy.o
endif

ifeq ($(CONFIG_BLK_DEV_XD),y)
L_OBJS += xd.o
else
  ifeq ($(CONFIG_BLK_DEV_XD),m)
  M_OBJS += xd.o
  endif
endif

ifeq ($(CONFIG_PARIDE),y)
SUB_DIRS        += paride
MOD_SUB_DIRS    += paride
else
  ifeq ($(CONFIG_PARIDE),m)
  MOD_SUB_DIRS  += paride
  endif
endif

ifeq ($(CONFIG_BLK_DEV_MD),y)
LX_OBJS += md.o

ifeq ($(CONFIG_MD_LINEAR),y)
L_OBJS += linear.o
else
  ifeq ($(CONFIG_MD_LINEAR),m)
  M_OBJS += linear.o
  endif
endif

ifeq ($(CONFIG_MD_STRIPED),y)
L_OBJS += raid0.o
else
  ifeq ($(CONFIG_MD_STRIPED),m)
  M_OBJS += raid0.o
  endif
endif

ifeq ($(CONFIG_MD_MIRRORING),y)
L_OBJS += raid1.o
else
  ifeq ($(CONFIG_MD_MIRRORING),m)
  M_OBJS += raid1.o
  endif
endif

ifeq ($(CONFIG_MD_RAID5),y)
L_OBJS += raid5.o
else
  ifeq ($(CONFIG_MD_RAID5),m)
  M_OBJS += raid5.o
  endif
endif

endif

ifeq ($(CONFIG_BLK_DEV_NBD),y)
L_OBJS += nbd.o
else
  ifeq ($(CONFIG_BLK_DEV_NBD),m)
  M_OBJS += nbd.o
  endif
endif

include $(TOPDIR)/Rules.make

=== kernel/snapshots/linux-2.5.31/drivers/block/Makefile ===
CCOPTS = -D__KERNEL__ -DMODULE -I../../include -I/usr/local/src/linux-2.5.12/include -O2 

enbd.o: enbd.c
	$(CC) $(CCOPTS) -c $^ -o $@

=== kernel/snapshots/linux-2.5.64/drivers/block/enbd/Makefile ===
#
# Makefile for ENBD (Peter T. Breuer ptb@it.uc3m.es)
#
#

obj-$(CONFIG_BLK_DEV_ENBD)		+= enbd.o
obj-$(CONFIG_BLK_DEV_ENBD_IOCTL)	+= enbd_ioctl.o

enbd-objs := enbd_base.o enbd_ioctl_stub.o enbd_seqno.o enbd_md.o enbd_speed.o enbd_proc.o

=== debian/changelog ===
enbd (2.4.31-20040412-1) unstable; urgency=low

  * upgrade client device special file detection logic to fallback to use any
    major+minor block device in the directory that is usable for the
    subchannels.  (Maybe) this allows use of the kernel nbd naming scheme.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Mon, 12 Apr 2004 12:17:41 +0100

enbd (2.4.31-20040411-1) unstable; urgency=low

  * support compile for UML with ARCH=um
  * rearranged debian scripts to cure install noise
    formally closes #201551 (noisy postinstall and prerem).
  * formally closes #215499 (/etc/services not modified for ages now).
  * formally closes #232818 (bad _IO declaration in various *.c fixed ages ago).

 -- Peter T. Breuer <ptb@it.uc3m.es>  Sun, 11 Apr 2004 12:17:41 +0100

enbd (2.4.31-20040410-1) unstable; urgency=low

  * fix compile under debian testing with 2.6 sources, hopefully
       (closes #239835).
  * add 2.6.3 kernel patch

 -- Peter T. Breuer <ptb@it.uc3m.es>  Sat, 10 Apr 2004 17:17:41 +0100

enbd (2.4.31-20040215-1) unstable; urgency=low

  * fix userspace _IO for 2.6.1 patch (closes #232818 before it opened)

 -- Peter T. Breuer <ptb@it.uc3m.es>  Sun, 15 Feb 2004 12:45:01 +0200

enbd (2.4.31-20031217-1) unstable; urgency=low

  * fix init.d/enbd script bug (left over debugging?).
  * edit debian/kpatch type stuff to tell it about more kernel patches.
  * minor fix to hash (init size calc) carried over from late 2.4.31
  * make server generate consistent random sig per hostnode and resource.
  * allow server to start even if can't make pidfile, allowing nonroot

 -- Peter T. Breuer <ptb@it.uc3m.es>  Wed, 17 Dec 2003 15:45:51 +0200

enbd (2.4.31-20031024-1) unstable; urgency=low

  * fix compile under libc5 via more autconf and fallback stuff.
  * somehow remove or workaround driver reference counting bug making
    it not notice that all clients have died and thus disable itself
    in that case (shows up with show_errs=1). This bug may come back
    if one uses partitions because (a) I'm not sure how I cleared it and
    (b) I cleared it only certainly in the case when there are no
    partitions, by introducing a fallback last-ditch reference counting
    method.  That method will be fooled if the subdevices are mounted
    and hence have one more reference count than the daemon alone.
    Anyway, the subdevices now have reference counters.
  * bump version number.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Fri, 24 Oct 2003 15:45:51 +0200

enbd (2.4.31-20030924-1) unstable; urgency=low

  * Allow enbd-test to work on files and dirs, not just devs.
  * Use spinlocks on slot to fix old clear/ack race in driver.
  * Make slot accounting counters atomic types, just in case.
  * Make 2.4.22 patch (closes #214497).

 -- Peter T. Breuer <ptb@it.uc3m.es>  Wed, 24 Sep 2003 18:10:33 +0200

enbd (2.4.31-20030911-1) unstable; urgency=low

  * Wrap gettimeofday against negative system time jumps.
  * Remove more remnants of builtin raid1 from driver.
  * Fix compile on ia64 (closes #205317).
  * Include MAKEDEV call in postinst (closes #209356)

 -- Peter T. Breuer <ptb@it.uc3m.es>  Thu, 11 Sep 2003 18:10:33 +0200

enbd (2.4.31-20030821-1) unstable; urgency=high

  * Heisenbug somewhere in enbd-client server_write() probably fixed.
  * Seek tests from Arne Wiebalck incorporated in enbd-test (-r too).
  * Minor Makefile fixes.
  * Fix nasty bug in init_module() in enbd_raw.c. Destructive one.
  * enbd-test.8 man page extended and updated (Arne Wiebalck).

 -- Peter T. Breuer <ptb@it.uc3m.es>  Thu, 21 Aug 2003 18:10:33 +0200

enbd (2.4.31-20030818-1) unstable; urgency=low

  * Separate binary-arch and binary-arch-indep deb builds.
    (Closes: Bug#205156).
  * Used ENBD_ prefix for all macros, instead of NBD_. Ditto enbd_
    instead of nbd_ for function names and structs.
  * Made enbd_raw.o module.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Mon, 18 Aug 2003 08:21:10 +0200

enbd (2.4.31-20030807-1) unstable; urgency=low

  * Rip out builtin raid1 support in favour of fr1 interface.
  * #ifdef use of raw interface.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Thu, 7 Aug 2003 12:26:13 +0200

enbd (2.4.31-20030717-1) unstable; urgency=low

  * Fix excess noise in init and postrm (closes: Bug#201551)
  * Add -h switch to server to control result cache size
  * Add lo/hi water marks to result cache
  * Move shrink cache down into result cache itself
  * Toughen microselect against ENOMEM from select

 -- Peter T. Breuer <ptb@it.uc3m.es>  Thu, 17 Jul 2003 16:09:01 +0200

enbd (2.4.31-20030623-1.1) unstable; urgency=low

  * NMU
  * debian/control :
    - Build-Depends (and not Build-Depends-Indep) on dh-kpatches
      (Closes: #200808).
    - Fix copyright-lists-upstream-authors-with-dh_make-boilerplate
      lintian warning in kernel-patch-enbd package.
    - Fix description-synopsis-might-not-be-phrased-properly lintian
      warning in kernel-patch-enbd package.
  * debian/rules :
    - Stop invoking dh_testversion as it's deprecated and the package
      is already using versioned dependencies on debhelper in its
      Build-Depends.

 -- Andre Luis Lopes <andrelop@debian.org>  Sat, 19 Jul 2003 22:16:15 -0300

enbd (2.4.31-20030623-1) unstable; urgency=low

  * Fix __BIG_ENDIAN misspelling (closes: Bug#198448)
  * Fix semaphore deadlock in callback from md_notify (raid, fr1)
  * Simplify md (fr1) ioctls
  * Add partition support in md (fr1) ioctls.
  * Set show_errors while remote_invalid asserted; more intuitive.
  * Make setting signature require a little more magic.
  * Add silly raw (iovec) and serial transfer modes - to go away again!
  * Fix typos (*->&, & -> &&) in FSYNC treatement in server.
  * Add FCNTL locking option in locking module.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Mon, 23 Jun 2003 03:49:02 +0200

enbd (2.4.31-20030506-1) unstable; urgency=low

  * Use fcntl instead of atomic kernel ops in lock.c. For portability.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Tue, 6 May 2003 12:18:22 +0200



=== debian/control ===
Source: enbd
Section: net
Priority: optional
Maintainer: Peter T. Breuer <ptb@it.uc3m.es>
Standards-Version: 3.5.10
Build-Depends: debhelper (>> 3.0.0), dh-kpatches

Package: enbd
Architecture: any
Depends: ${shlibs:Depends}
Suggests: kernel-patch-enbd
Description: Enhanced Network Block Device support
 This is a client/server package supporting the enbd kernel module.
 Enbd-client proxies kernel requests, passing them across the net to a
 remote enbd-server daemon. In conjunction with the kernel module to
 which the client talks, this makes the remote resource on the server
 appear as a local block device.  NBDs may be treated like any other
 block device.  In particular, they may have file systems made on them
 and then may be mounted into the local file system tree.  This package
 contains the userland support daemons for the Enhanced NBD kernel
 driver.
 .
 Regular updates will be found at
 ftp://oboe.it.uc3m.es/pub/Programs/, and the project web page is at
 http://www.it.uc3m.es/ptb/enbd/. Go to www.freshmeat.net and look up
 "ENBD" for more recent public release announcements.

Package: kernel-patch-enbd
Architecture: all
Depends: ${kpatch:Depends}
Suggests: kernel-source, kernel-package, enbd
Description: Enhanced Network Block Device support kernel patch
 This is the kernel patch required by the enbd-client from the enbd
 package.
 .
 Regular updates to this patch will be found at
 ftp://oboe.it.uc3m.es/pub/Programs/, and the project web page is at
 http://www.it.uc3m.es/ptb/enbd/.  Go to www.freshmeat.net and look up
 "ENBD" for more recent public release announcements.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=2

# config variables for debian. Maybe use include conf.debian for these?
       VPATH   := $(shell pwd)
export DEBUG   := 0
export prefix  := /usr
export datadir := $(prefix)/share
export docdir  := $(datadir)/doc
export mandir  := $(datadir)/man
export localstatedir := /var
export sysconfdir    := /etc
export srcdir  := $(prefix)/src
       ARCH    := $(shell arch)
export BUILD   := $(VPATH)/debian/build
       NAME    := enbd
       VERSION := $(shell grep urgency debian/changelog | head -1 | sed -e 's/.*(\(.*\)).*/\1/' | sed -e 's/-[0-9]*$$//')
       PATCH   := 1
       PACKAGE := $(NAME)_$(VERSION)-$(PATCH)_$(ARCH).deb
export CFLAGS  := -O2 -Wall -D_LARGEFILE64_SOURCE=1 -D_GNU_SOURCE=1 \
                            -D_XOPEN_SOURCE=1 -DLARGEFILE_SOURCE=1 \
                            -D_FILE_OFFSET_BITS=64
export EXTRA_CFLAGS := -I$(BUILD) \
                       -I$(VPATH)/kernel/linux/include \
                       -DDEBUG=$(DEBUG)
       TMPDIR   := /tmp

build: build-arch build-indep
build-arch: build-arch-stamp
build-arch-stamp:
	dh_testdir -a
	# Add here commands to compile the package.
	mkdir -p $(BUILD) ; \
	export CONFIG_SITE=$(VPATH)/nbd/conf/config.$(SYSTEM); \
	cd $(BUILD);  $(VPATH)/nbd/configure \
	--srcdir=$(VPATH)/nbd  \
	--prefix=$(prefix) \
	--localstatedir=$(localstatedir) \
	--sysconfdir=$(sysconfdir) \
	--mandir=$(mandir); \
	$(MAKE) VPATH=$(VPATH)/nbd \
	        CFLAGS="$(CFLAGS) $(EXTRA_CFLAGS)" \
	        EXTRA_LIBS="$(EXTRA_LDFLAGS) \
                        $(LIBS) \
                        $(EXTRA_LIBS)" \
	        all
	touch $@

build-indep: build-indep-stamp
build-indep-stamp:
	dh_testdir -i
	mkdir -p $(BUILD)
	touch $@

clean: clean-arch clean-indep
clean-indep:
	dh_testdir -i
	dh_testroot -i
	rm -f build-indep-stamp
	rm -fr debian/tmp debian/build/* debian/$(TMPDIR) debian/kernel-patch-enbd
	dh_clean -i

clean-arch:
	dh_testdir -a
	dh_testroot -a
	rm -f build-arch-stamp
	# Add here commands to clean up after the build process.
	-$(MAKE) -C $(BUILD) \
	     VPATH=$(VPATH)/nbd \
	     CFLAGS="$(CFLAGS) $(EXTRA_CFLAGS)" \
	     LIBS="$(EXTRA_LDFLAGS) \
                     $(LIBS) \
                     $(EXTRA_LIBS)" \
	     clean ; \
	rm -fr debian/tmp debian/build/* debian/$(TMPDIR)
	dh_clean -a

install: install-arch install-indep
install-indep: build-indep
	dh_testdir -i
	dh_testroot -i
	dh_clean -k -i
	dh_installdirs -i
	mkdir -p debian/$(TMPDIR)/$(srcdir)
	mkdir -p debian/$(TMPDIR)/$(docdir)
	dh_installkpatches -i

install-arch: build-arch
	dh_testdir -a
	dh_testroot -a
	dh_clean -k -a
	dh_installdirs -a
	# Add here commands to install the package into debian/enbd.
	mkdir -p debian/$(TMPDIR)/$(sysconfdir) 
	mkdir -p debian/$(TMPDIR)/$(localstatedir)/state/nbd
	mkdir -p debian/$(TMPDIR)/$(mandir)
	mkdir -p debian/$(TMPDIR)/$(srcdir)
	-cp -a $(VPATH)/nbd/etc/enbd.conf debian/$(TMPDIR)/$(sysconfdir)/
	-$(MAKE)  -C $(BUILD) \
	     VPATH=$(VPATH)/nbd \
	     BUILD=$(BUILD) \
	     DESTDIR=$(VPATH)/debian/$(TMPDIR) \
             POSTINST=$(VPATH)/debian/postinst \
	     install-binary install-man install-doc
        # adjustments for debian
	rm -f $(VPATH)/debian/$(TMPDIR)/usr/share/doc/enbd/LICENCE
	mv $(VPATH)/debian/$(TMPDIR)/usr/share/doc/enbd/INSTALL $(VPATH)/debian/$(TMPDIR)/usr/share/doc/enbd/QUICK-INSTALL

# Build architecture-independent files here.
debian-binary-indep: install-indep
	dh_movefiles -i
	dh_installdocs -i
	dh_installchangelogs  -i
	dh_link -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-indep:
	$(MAKE) -f debian/rules debian-binary-indep

# Build architecture-dependent files here.
debian-binary-arch: build-arch install-arch
#	dh_testversion -a
#	dh_testdir -a
#	dh_testroot -a
#	dh_installdebconf	 -a
	dh_movefiles -a
	dh_installdocs -a
	dh_installexamples -a
#	dh_installmenu -a
#	dh_installemacsen -a
#	dh_installpam -a
	dh_installinit -a
#	dh_installcron -a
	dh_installman -a
#	dh_installmanpages -a
	dh_installinfo -a
#	dh_undocumented -a
	dh_installchangelogs  -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	# You may want to make some executables suid here.
#	dh_suidregister -a
#	dh_makeshlibs -a
	dh_installdeb -a
#	dh_perl -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary-arch:
	$(MAKE) -f debian/rules debian-binary-arch || \
	$(MAKE) -f debian/rules generic-binary-arch

generic-binary-arch: 
	( cd debian/$(TMPDIR); find * -type f | xargs md5sum ) > debian/md5sums
	tar czvfC $(BUILD)/control.tar.gz debian postinst prerm conffiles md5sums control 
	tar czfC $(BUILD)/data.tar.gz  debian/$(TMPDIR) .
	ar r ../$(PACKAGE) $(BUILD)/control.tar.gz $(BUILD)/data.tar.gz

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
